'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-2a6e6244.js');

const bpSdkCreateAppFormCss = "";

let BpSdkCreateAppForm = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /**
     * Is button disabled
     */
    this.buttonDisabled = false;
    /**
     * Text to display
     */
    this.text = 'Create New App Form';
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-create-app-form');
    customElements.whenDefined('bp-sdk-external-create-app-form').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-create-app-form", { buttonDisabled: this.buttonDisabled, createAppFormHandler: this.createAppFormHandler, text: this.text }));
  }
  renderInternal() {
    return (index.h("div", { class: "bp-sdk-create-app-form__container" }, index.h("bp-sdk-create-app-form-button", { text: this.text, buttonDisabled: this.buttonDisabled, onClick: this.createAppFormHandler })));
  }
};
BpSdkCreateAppForm.style = bpSdkCreateAppFormCss;

exports.bp_sdk_create_app_form = BpSdkCreateAppForm;
