import { Component, h, State, Prop } from '@stencil/core';
export class BpSdkBusinessClassificationSelectorCardContent {
  constructor() {
    /**
     * Should show explanation
     */
    this.showExplanation = true;
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-business-classification-selector-card-content');
    customElements.whenDefined('bp-sdk-external-business-classification-selector-card-content').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (h("bp-sdk-external-business-classification-selector-card-content", { alias: this.alias, value: this.value, highlights: this.highlights, confidence: this.confidence, explanation: this.explanation, showExplanation: this.showExplanation, showConfidence: this.showConfidence, showNaicsCode: this.showNaicsCode, showDetailedRelevanceChip: this.showDetailedRelevanceChip, isSelected: this.isSelected, isBestMatch: this.isBestMatch }));
  }
  renderInternal() {
    return (h("div", { class: "bp-sdk-business-classification-selector-card-content__container" },
      h("bp-sdk-business-classification-selector-card-header", { alias: this.alias, confidence: this.confidence, showConfidence: this.showConfidence, showNaicsCode: this.showNaicsCode, value: this.value, highlights: this.highlights }),
      h("bp-sdk-business-classification-selector-card-body", { explanation: this.explanation }),
      this.showDetailedRelevanceChip && h("bp-sdk-business-classification-selector-relevance-chip", { confidence: this.confidence })));
  }
  static get is() { return "bp-sdk-business-classification-selector-card-content"; }
  static get originalStyleUrls() { return {
    "$": ["./bp-sdk-business-classification-selector-card-content.css"]
  }; }
  static get styleUrls() { return {
    "$": ["bp-sdk-business-classification-selector-card-content.css"]
  }; }
  static get properties() { return {
    "alias": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "Alias for choice"
      },
      "attribute": "alias",
      "reflect": false
    },
    "value": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "Value for choice"
      },
      "attribute": "value",
      "reflect": false
    },
    "highlights": {
      "type": "unknown",
      "mutable": false,
      "complexType": {
        "original": "IChoiceHighlight[] | undefined",
        "resolved": "IChoiceHighlight[]",
        "references": {
          "IChoiceHighlight": {
            "location": "import",
            "path": "@boldpenguin/sdk-types"
          }
        }
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "List of highlight's"
      }
    },
    "confidence": {
      "type": "number",
      "mutable": false,
      "complexType": {
        "original": "number",
        "resolved": "number",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "Confidence level"
      },
      "attribute": "confidence",
      "reflect": false
    },
    "explanation": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "Explanation of choice"
      },
      "attribute": "explanation",
      "reflect": false
    },
    "showExplanation": {
      "type": "boolean",
      "mutable": false,
      "complexType": {
        "original": "boolean",
        "resolved": "boolean",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "Should show explanation"
      },
      "attribute": "show-explanation",
      "reflect": false,
      "defaultValue": "true"
    },
    "showConfidence": {
      "type": "boolean",
      "mutable": false,
      "complexType": {
        "original": "boolean",
        "resolved": "boolean",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "Should show confidence"
      },
      "attribute": "show-confidence",
      "reflect": false
    },
    "showNaicsCode": {
      "type": "boolean",
      "mutable": false,
      "complexType": {
        "original": "boolean",
        "resolved": "boolean",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "Should show naics code"
      },
      "attribute": "show-naics-code",
      "reflect": false
    },
    "showDetailedRelevanceChip": {
      "type": "boolean",
      "mutable": false,
      "complexType": {
        "original": "boolean",
        "resolved": "boolean",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "Show detailed relevance chip"
      },
      "attribute": "show-detailed-relevance-chip",
      "reflect": false
    },
    "isSelected": {
      "type": "boolean",
      "mutable": false,
      "complexType": {
        "original": "boolean",
        "resolved": "boolean",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "Is choice selected"
      },
      "attribute": "is-selected",
      "reflect": false
    },
    "isBestMatch": {
      "type": "boolean",
      "mutable": false,
      "complexType": {
        "original": "boolean",
        "resolved": "boolean",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "Is best match choice"
      },
      "attribute": "is-best-match",
      "reflect": false
    }
  }; }
  static get states() { return {
    "useExternal": {}
  }; }
}
