import { r as registerInstance, c as createEvent, h } from './index-b4e0290f.js';

const bpSdkBackButtonCss = "";

let BpSdkBackButton = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.navigateBack = createEvent(this, "navigateBack", 7);
    /**
     * Back button text
     */
    this.text = '';
    /**
     * Icon name
     */
    this.icon = 'chevron-left';
    /**
     * Controls disabled state of button
     */
    this.buttonDisabled = false;
    this.useExternal = false;
  }
  resetState() { }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-back-button');
    customElements.whenDefined('bp-sdk-external-back-button').then(() => {
      this.useExternal = true;
    });
    this.isButtonDisabled(this.buttonDisabled);
  }
  isButtonDisabled(isDisabled) {
    this.buttonDisabled = isDisabled;
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (h("bp-sdk-external-back-button", { buttonDisabled: this.buttonDisabled, cssClasses: this.cssClasses, icon: this.icon, text: this.text }));
  }
  renderInternal() {
    return (h("div", { class: "bp-sdk-back-button__container" }, h("bp-sdk-button", { onClick: () => this.navigateBack.emit(), text: this.text, buttonDisabled: this.buttonDisabled, class: this.cssClasses }, h("bp-sdk-icon-container", { name: this.icon }))));
  }
  static get watchers() { return {
    "buttonDisabled": ["isButtonDisabled"]
  }; }
};
BpSdkBackButton.style = bpSdkBackButtonCss;

export { BpSdkBackButton as bp_sdk_back_button };
