import { r as registerInstance, h } from './index-b4e0290f.js';

const bpSdkCreateAppFormCss = "";

let BpSdkCreateAppForm = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    /**
     * Is button disabled
     */
    this.buttonDisabled = false;
    /**
     * Text to display
     */
    this.text = 'Create New App Form';
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-create-app-form');
    customElements.whenDefined('bp-sdk-external-create-app-form').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (h("bp-sdk-external-create-app-form", { buttonDisabled: this.buttonDisabled, createAppFormHandler: this.createAppFormHandler, text: this.text }));
  }
  renderInternal() {
    return (h("div", { class: "bp-sdk-create-app-form__container" }, h("bp-sdk-create-app-form-button", { text: this.text, buttonDisabled: this.buttonDisabled, onClick: this.createAppFormHandler })));
  }
};
BpSdkCreateAppForm.style = bpSdkCreateAppFormCss;

export { BpSdkCreateAppForm as bp_sdk_create_app_form };
