import { r as registerInstance, h } from './index-b4e0290f.js';
import { e as fx } from './index.esm.min-a0c9e6cc.js';

const bpSdkVehicleVinInputCss = "";

let BpSdkVehicleVinInput = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    /**
     * Is pristine
     */
    this.pristine = true;
    /**
     * Is touched
     */
    this.touched = false;
    /**
     * Error messages
     */
    this.errors = [];
    this.labelId = fx(8);
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-vehicle-vin-input');
    customElements.whenDefined('bp-sdk-external-vehicle-vin-input').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (h("bp-sdk-external-vehicle-vin-input", { code: this.code, errors: this.errors, label: this.label, labelId: this.labelId, pristine: this.pristine, touched: this.touched }));
  }
  renderInternal() {
    return (h("div", { class: "bp-sdk-vehicle-vin-input__container" }, h("bp-sdk-text-input", { code: this.code, errors: this.errors, fieldType: 'text', label: this.label, labelId: this.labelId, placeholder: "Vin", pristine: this.pristine, questionId: this.labelId, touched: this.touched, text: this.value })));
  }
};
BpSdkVehicleVinInput.style = bpSdkVehicleVinInputCss;

export { BpSdkVehicleVinInput as bp_sdk_vehicle_vin_input };
