import { EventEmitter } from '../../stencil-public-runtime';
import { ICheckboxInputComponent } from '@boldpenguin/sdk-types';
export declare class BpSdkCheckboxInput implements ICheckboxInputComponent {
  /**
   * Answer id
   */
  answerId: string;
  /**
   * Question Id
   */
  questionId: string;
  /**
   * Field type
   */
  fieldType: string;
  /**
   * Checkbox errors
   */
  errors: string[];
  /**
   * Error message to display
   */
  errorText: string;
  /**
   * Question code
   */
  code: string;
  /**
   * Question value
   */
  value: boolean;
  /**
   * Label to display
   */
  label: string;
  /**
   *  Labels that describe group
   */
  labelledBy: string;
  /**
   * Is required
   */
  required: boolean;
  /**
   * Is touched
   */
  touched: boolean;
  /**
   * is pristine
   */
  pristine: boolean;
  /**
   * Is answer in complete state
   */
  isCompleted: boolean;
  /**
   * When true, the field will be readonly. It will display only the label and value as plain text.
   */
  isReadOnly: boolean;
  /**
   * Help text
   */
  helpText: string;
  /**
   * Specifically how the question was answered (ie. "ACORD 126")
   */
  answeredBySource: string | undefined;
  id: string;
  useExternal: boolean;
  valueUpdate: EventEmitter<boolean>;
  onCodeChange(code: string): void;
  onAnswerIdChange(answerId: string): void;
  updateId(code: string, answerId: string): void;
  resetState(): void;
  connectedCallback(): void;
  componentWillLoad(): void;
  onChange: (ev: InputEvent) => void;
  render(): any[];
  renderExternal(): any;
  renderInternal(): any;
  renderReadOnlyElement(value: string): any;
}
