import { EventEmitter } from '../../stencil-public-runtime';
import { Unsubscribe } from '@stencil/redux';
import { IAnswer, IDriverInputContainerComponent } from '@boldpenguin/sdk-types';
import { BpSdkStore } from '@boldpenguin/sdk-redux';
export declare class BpSdkDriverInputContainer implements IDriverInputContainerComponent {
  storeUnsubscribe?: Unsubscribe;
  static readonly ERROR_MESSAGE = "Driver's license is invalid for state";
  /**
   * Answer id
   */
  answerId: string;
  /**
   * Question id
   */
  questionId: string;
  /**
   * Question group id
   */
  questionGroupId: string;
  /**
   * Question pool id
   */
  questionPoolId: string;
  /**
   * Initial text value
   */
  text: string;
  /**
   * Aria label id's that describes input for screen readers
   */
  labelId: string;
  /**
   * Field type
   */
  fieldType: string;
  /**
   * Placeholder to display
   */
  placeholder: string;
  /**
   * Regular expression pattern input should match
   */
  pattern: string | undefined;
  /**
   * Question code
   */
  code: string;
  /**
   * Is question required
   */
  required: boolean;
  /**
   * minimum length of input
   */
  min: number;
  /**
   * maximum length of input
   */
  max: number;
  /**
   * Error messages
   */
  errors: string[];
  /**
   * Error text
   */
  errorText: string;
  /**
   * is touched
   */
  touched: boolean;
  /**
   * is pristine
   */
  pristine: boolean;
  /**
   * Is answer in complete state
   */
  isCompleted: boolean;
  /**
   * When true, the field will be readonly. It will display only the label and value as plain text.
   */
  isReadOnly: boolean;
  /**
   * Label
   */
  label: string;
  /**
   *  Labels that describe group
   */
  labelledBy: string;
  /**
   * Is enabled
   */
  isEnabled: boolean;
  /**
   * Reference type
   */
  referenceType: string;
  /**
   * Driver license state answer injected by redux
   */
  driverLicenseStateAnswer: IAnswer | undefined;
  /**
   * Help text
   */
  helpText: string;
  useExternal: boolean;
  licenseError: string | undefined;
  /**
   * Value change event
   */
  fakeValueUpdate: EventEmitter<void>;
  resetState(): void;
  connectedCallback(): void;
  componentWillLoad(): void;
  handleSubscriptions(): void;
  disconnectedCallback(): void;
  onSaveAnswer(e: CustomEvent<string>): void;
  mapStateToProps: (state: BpSdkStore) => {
    driverLicenseStateAnswer: IAnswer;
  };
  render(): any[];
  renderExternal(): any;
  renderInternal(): any;
}
