import { IChoice, IProductListComponent } from '@boldpenguin/sdk-types';
export declare class BpSdkProductList implements IProductListComponent {
  /**
   * Answer id
   */
  answerId: string;
  /**
   * Specifically how the question was answered (ie. "ACORD 126")
   */
  answeredBySource: string | undefined;
  /**
   * Selected choice id
   */
  choiceId: string;
  /**
   * Selected choice ids
   */
  choiceIds: string[];
  /**
   * Choices to display
   */
  choices: IChoice[];
  /**
   * question code
   */
  code: string;
  /**
   * Error text
   */
  errorText: string | undefined;
  /**
   * Field type
   */
  fieldType: string;
  /**
   * Help text
   */
  helpText: string;
  /**
   * Is multiple
   */
  isMultiple: boolean;
  /**
   * When true, the field will be readonly. It will display only the label and value as plain text.
   */
  isReadOnly: boolean;
  label: string;
  /**
   *  Labels that describe group
   */
  labelledBy: string;
  /**
   * Is Pristine
   */
  pristine: boolean;
  /**
   * Question Id
   */
  questionId: string;
  /**
   * Is required?
   */
  required: boolean;
  /**
   * Is touched
   */
  touched: boolean;
  useExternal: boolean;
  componentWillLoad(): void;
  render(): any[];
  renderExternal(): any;
  renderInternal(): any;
}
